TeVeO/urls.py
from django.urls import path
from . import views


urlpatterns = [
    #indica al dispacher que tiene que ir a la vista main
    path('', views.main, name='main'),
    #indica al dispacher que tiene que ir a la vista de configuracion
    path('configuracion/', views.configuracion, name='configuracion'),
    #indica al dispacher que tiene que ir a la vista autorizar
    path('autorizar', views.autorizar, name='autorizar'),
    #indica al dispacher que tiene que ir a la vista terminar
    path('terminar/', views.terminar_session, name='terminar'),
    #indica al dispacher que tiene que ir a la vista ayuda
    path('ayuda/', views.ayuda, name='ayuda'),
    #indica al dispacher que tiene que ir a la vista jsoncamara
    path('json', views.jsonCamara, name="jsonCamara"),
    #indica al dispacher que tiene que ir a la vista camaras
    path('camaras/', views.camaras, name="camaras"),
    #indica al dispacher que tiene que ir a la vista para poner comentarios
    path('comentario', views.poner_comentario, name="comentario"),
    #indica al dispacher que tiene que ir a la vista comentarios
    path('comentarios', views.devolver_comentario, name="comentarios"),
    #indica al dispacher que tiene que ir a la vista de la camara dinamica
    path('<str:id>-dyn/', views.camaradyn, name="camara-dyn"),
    #indica al dispacher que tiene que ir a la vista main de la imagen
    path('image', views.image, name="image"),
    #indica al dispacher que tiene que ir a la vista de la imagen embebida
    path('image_embedded/', views.image_embedded, name="image_embedded"),
    #indica al dispacher que tiene que ir a la vista de la camara
    path('<str:id>/', views.camara, name="camara"),
    #indica al dispacher que tiene que ir a la vista css
    path("css", views.css, name="style"),
    #indica al dispacher que tiene que ir a la vista bootstrapp
    path("bootstrapp", views.boot, name="bootstrapp"),

]

final/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path("", include("TeVeO.urls")),
]

TeVeO/models.py
from django.db import models

# Create your models here.
class Configuracion(models.Model):
    """
    Base de datos usada para guardar informacion acerta del nombre del visitante, tamaño y tipo de letra
    """

    sessionid = models.CharField(max_length=100, primary_key=True, default='')
    nombre = models.CharField(default="Anonimo", max_length=100)
    size = models.CharField(max_length=100)
    tipo = models.CharField(max_length=100)


class Camara(models.Model):
    """
    Base de datos encargada de guardar la informacion sobre una camara
    """

    id = models.CharField(max_length=100, primary_key=True)
    source = models.URLField()
    lugar = models.CharField(max_length=200)
    longitud = models.CharField(max_length=200, default="")
    latitud = models.CharField(max_length=200, default="")


class Comentario(models.Model):
    """
    Base de datos encargada de guardar la informacion sobre un comentario, asociado a una camara
    """
    camera = models.ForeignKey(Camara, on_delete=models.CASCADE)
    autor = models.CharField(default="Anonimo",max_length=100)
    fecha = models.DateTimeField(auto_now_add=True)
    comentario = models.TextField()
    imagen = models.TextField(null=True, blank=True)


class Listas(models.Model):
    """
    Base de datos encargada de guardar el valor de si se ha descargado o no una lista de camaras
    """
    lista_1 = models.BooleanField(default=False)
    lista_2 = models.BooleanField(default=False)
    lista_3 = models.BooleanField(default=False)
    lista_4 = models.BooleanField(default=False)


class LikeCamara(models.Model):
    camara = models.ForeignKey(Camara, on_delete=models.CASCADE)

TeVeO/views.py
from django.shortcuts import render,  redirect
from django.http import HttpResponse, Http404
from django.utils import timezone
from django.urls import reverse
import base64
import random
from .camarasHandler import CameraInfo
from .camarasL2Handler import CameraInfo2
from .camaraVitoriaHandler import download_cameras
from .camaraMeteoGalicia import download_galicia
from .models import Camara, Comentario, Configuracion, Listas, LikeCamara
import urllib.request
import urllib.error
import urllib.parse
import json
import uuid
from django.core.paginator import Paginator, PageNotAnInteger, EmptyPage


def main(request):
    """
    Se encargar de devolver la pagina principal,
    donde se ve una serie de comentarios puestos
    por los visitantes

    :param request:
    :return: pagina principal de la app
    """
    try:
        # Obtener los comentarios ordenados de más reciente a más antiguo
        comentarios = Comentario.objects.all().order_by("-fecha")
        # Obtener todas las cámaras
        camaras = Camara.objects.all()
        # Obtener el ID de sesión del navegador actual
        session_id = request.session.get("session_id")
        confi = Configuracion.objects.filter(sessionid=session_id).exists()
        if not session_id or not confi:
            # Si no hay un ID de sesión, o no existe una
            # configuración para este ID de sesión,
            # crear uno nuevo y guardar la configuración
            # predeterminada para esta sesión
            session_id = str(uuid.uuid4())
            request.session["session_id"] = session_id
            configuracion = (Configuracion
                             (sessionid=session_id,
                              nombre="Anónimo",
                              size="medium",
                              tipo="serif"))
            configuracion.save()
        else:
            # Obtener la configuración específica de esta sesión
            configuracion = Configuracion.objects.get(sessionid=session_id)
        # Muestra 10 comentarios por página
        paginador = Paginator(comentarios, 3)
        numero_pagina = request.GET.get("page")
        try:
            pagina_comentarios = paginador.page(numero_pagina)
        except PageNotAnInteger:
            pagina_comentarios = paginador.page(1)
        except EmptyPage:
            pagina_comentarios = paginador.page(paginador.num_pages)

        # Devolver la página con la configuración y otros datos necesarios
        return render(request, "TeVeO/main.html",
                      {"comentarios": pagina_comentarios,
                       "camaras": camaras,
                       "configuracion": configuracion})
    except (Comentario.DoesNotExist, Camara.DoesNotExist):
        return render(request, "TeVeO/main.html", {})


def descargarLista4():
    """
    Funcion encargada de descargar la lista de camaras
    de las lista de Meteo Galicia

    """
    url = ("https://servizos.meteogalicia.gal"
           "/mgrss/observacion/jsonCamaras.action")

    download_galicia(url)


def descargarLista3():
    """
    Funcion encargada de descargar la lista de camaras
    de las lista de Meteo Galicia

    """
    url = ("https://www.vitoria-gasteiz.org"
           "/c11-01w/cameras?action=list&format=GEOJSON")

    download_cameras(url)


def descargarLista2():
    """
    Funcion encargada de descargar el contenido relacionado con la lista2

    """
    url = ("https://gitlab.eif.urjc.es/cursosweb"
           "/2023-2024/final-teveo/-/raw/main/listado2.xml")
    xml = urllib.request.urlopen(url)
    CameraInfo2(xml)


def descargarLista1():
    """
    Funcion encargada de descargar el contenido relacionado con la lista1

    """
    url = ("https://gitlab.eif.urjc.es/cursosweb"
           "/2023-2024/final-teveo/-/raw/main/listado1.xml")
    xml = urllib.request.urlopen(url)
    CameraInfo(xml)


def order_num_coments(camaras):
    """
    Funcion que nos devuelve las camaras,
    ordenes segun el que tenga mayor comentarios
    """
    cams = []

    for i in camaras:
        longitu_coment = len(Comentario.objects.filter(camera=i))
        cams.append((i, longitu_coment))

    for i in range(len(cams)):
        for j in range(i+1, len(cams)):
            if cams[i][1] > cams[j][1]:
                cams[i], cams[j] = cams[j], cams[i]

    camaras_ordernas = []
    for cam, _ in reversed(cams):
        camaras_ordernas.append(cam)

    return camaras_ordernas


def jsonCamara(request):

    id = request.GET.get("id")

    camara = Camara.objects.get(id=id)

    info = {
        "id": camara.id,
        "source": camara.source,
        "lugar": camara.lugar,
        "latitud": camara.latitud,
        "longitud": camara.longitud,
        "num_comentarios":  len(Comentario.objects.filter(camera=id)),
        "likes": len(LikeCamara.objects.filter(camara=id)),
    }

    return HttpResponse(json.dumps(info), content_type="application/json")


def camaras(request):
    """
    Vista encargada de , si llega un POST,
    esto quiere decir que se decarga una de las listas,
    decarga el contenido de las lista y lo guarda en la base de datos
    Si le llega un GET,
    devuelve la pagina de las camaras con las camaras descargadas

    :param request:
    :return: redireciona siempre a la pagina de las camras
    """
    if request.method == "POST":
        # Crea un objeto lista o devuelve el que se crea,
        # no se le añade ningun parametro mas porque solo quiero uno
        Lista, _ = Listas.objects.get_or_create()
        # Si en el POST se encuentra en name lista1,
        # y el valor del modelo es not False=True
        if "lista1" in request.POST and not Lista.lista_1:
            # Cambio el valor del booleano del modelo
            Lista.lista_1 = True
            Lista.save()
            # Descargo el contenido de la lista1
            descargarLista1()

        # Si en el POST se encuentra en name lista2,
        # y el valor del modelo es not False=True
        elif "lista2" in request.POST and not Lista.lista_2:
            # Cambio el valor del booleano del modelo
            Lista.lista_2 = True
            Lista.save()
            # Descargo el contenido de la lista2
            descargarLista2()

        elif "lista3" in request.POST and not Lista.lista_3:
            # Cambio el valor del booleano del modelo
            Lista.lista_3 = True
            Lista.save()
            # Descargo el contenido de la lista3
            descargarLista3()

        elif "lista4" in request.POST and not Lista.lista_4:
            # Cambio el valor del booleano del modelo
            Lista.lista_4 = True
            Lista.save()
            # Descargo el contenido de la lista4
            descargarLista4()
        # Redireciono a la pagina de las camars
        return redirect("camaras")

    elif request.method == "GET":
        try:
            camaras = Camara.objects.all()
            camaras_ordenadas = order_num_coments(camaras)
            longitud_comentarios = len(Comentario.objects.all())
            if camaras:
                img = random.choice(camaras)
            else:
                img = None
            # Me crep un objeto paginador
            paginador = Paginator(camaras_ordenadas, 3)
            # Obtengo la pagina
            numero_pagina = request.GET.get("page")
            try:
                numero_camras = paginador.page(numero_pagina)
            except PageNotAnInteger:
                numero_camras = paginador.page(1)
            except EmptyPage:
                numero_camras = paginador.page(paginador.num_pages)
            c = (Configuracion.objects.get
                 (sessionid=request.session.get("session_id")))
            return render(request, "TeVeO/camaras.html",
                          {"camaras": numero_camras,
                           "longitud_comentarios": longitud_comentarios,
                           "imagen_random": img,
                           "configuracion": c})
        except Configuracion.DoesNotExist:
            return redirect("main")


def camara(request, id):
    """

    Esta view se encarga de devolver la pagina html
    relacionada al id , es decir, una pagina
    en la que se ve la informacion de una camara

    :param request:
    :param id: identificador de la camara
    :return: Pagina html con el contenido de la camara y comentarios
    """

    if request.method == "GET":
        # Longitud de las camaras
        longitud_camaras = len(Camara.objects.all())
        # Longitud de los comentarios
        longitud_comentarios = len(Comentario.objects.all())
        try:
            # Obtengo la camara con id=id
            camara = Camara.objects.get(id=id)
            # Obtenemos los comentarios ordenados,
            # odenados de mas reciente a mas antiguo,
            # el -fecha lo que dice es que me lo
            # devuelva el valor mas alto al mas bajo.
            comentarios = (Comentario.objects.filter
                           (camera=camara).order_by("-fecha"))
            c = (Configuracion.objects.get
                 (sessionid=request.session.get("session_id")))
            return render(request, "TeVeO/camara.html",
                          {"camara": camara,
                           "comentarios": comentarios,
                           "longitud_camaras": longitud_camaras,
                           "longitud_comentarios": longitud_comentarios,
                           "configuracion": c})
        except Camara.DoesNotExist:
            return HttpResponse(f"No existe la ninguna camara "
                                f"con el identificador {id}", status=404)
        except Configuracion.DoesNotExist:
            return redirect("main")

    elif request.method == "POST":
        camara = Camara.objects.get(id=id)
        like = request.POST.get("like")
        if like:
            Like = LikeCamara(camara=camara)
            Like.save()
        return redirect("camara", id=id)

TeVeO/templates/TeVeO/ayuda.html
<!DOCTYPE html>
{% load static %}

<html lang="en">
<head>
    <meta charset="UTF-8">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <script src="//maxcdn.bootstrapcdn.com/bootstrap/4.1.1/js/bootstrap.min.js"></script>
    <script src="//cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    <link href="{% url 'style' %}" rel="stylesheet">
    <link href="{% url 'bootstrapp' %}" rel="stylesheet">
    <link rel="shortcut icon" type="image/x-icon" href="{% static 'favicon.ico' %}">
    <title>Title</title>
</head>
<body>
    <header>
        <section id="tabs">
                <div class="container green-bg">
                    <h6 class="section-title h1"><a href="/">TeVeO</a></h6>
                    <h5>Te has registrado como: {{ configuracion.nombre }}</h5>
                </div>

                <div class="container black-bg">
                    <nav>
                        <div class="nav nav-tabs nav-fill" id="nav-tab" role="tablist">
                            <a class="nav-item nav-link" id="nav-home-tab" data-toggle="tab" href="/" role="tab" aria-controls="nav-home" aria-selected="true">Principal</a>
                            <a class="nav-item nav-link" id="nav-home-tab" data-toggle="tab" href="/camaras" role="tab" aria-controls="nav-home" aria-selected="true">Camaras</a>
                            <a class="nav-item nav-link" id="nav-about-tab" data-toggle="tab" href="/configuracion" role="tab" aria-controls="nav-about" aria-selected="false">Configuracion</a>
                            <a class="nav-item nav-link" id="nav-admin-tab" data-toggle="tab" href="/admin" role="tab" aria-controls="nav-admin" aria-selected="false">Admin</a>
                        </div>
                    </nav>
                </div>
        </section>
    </header>
    <div id="camera-box">
        <p> En el recurso / nos ofrece una pagina donde se pueden ver todos los comentarios puestos a diferentes camaras</p>
        <p> En el recurso /camaras, nos ofre una seria de camaras a descargar y en cada camara unos link que nos mandan a la pagina de la camara y camara dinamica selecionada</p>
        <p> En el recurso /id, donde id es el identificador de una camara, nos devuelve una pagina con la informacion al respecto de una camara junto a su imagen en ese momento y un link para acceder a la pagina dinamica y para comentarsobre esa camara</p>
        <p> En el recurso /id-dyn, donde id es el identificador de una camara, nos devuelve una pagina con la informacion al respecto de una camara junto a su imagen que se actualiza cada 30s y un link para acceder a la pagina de la camara y para comentarsobre esa camara</p>
        <p>En el recurso /comentario/?id=id, donde id es el identicador de una de las camaras, nos devuelve una pagina con informacion de la camara, la hora actual, y una imagen de ese momento, tambien hay un formulario para poner un comentario</p>
        <p>En el recurso /configuracion, da una pagina en la que nos deja poner un nombre, y configurar el tipo de letra y tamano que queremos</p>
        <p>En el recurso /ayuda, da una pagina en la que aparecera una breve explicacion de la app</p>
        <h3>Documentacion</h3>
        <p>En la todas las paginas aparecera una barra que nos permite ir a los recurso descritos anteriormente, y un pie de pagina, en la nos dice el numero de camaras activas y comentarios. En la pagina pricipal aparecera
         una serie de comentarios puestos sobre ciertas camaras, con su identicandor que nos redirecionara a la pagina de esa camara, ademas tendremos un boton que nos ensenara el contenido JSON de las camaras. En las paginas de las camaras tendremos dos botones para descargar el contenido respecto a las
        listas, una vez descargadas, apareceran las camaras descargadas, indicando el numero de comentarios, y dos links para acceder a la pagina de camara o la pagina dinamica de camara, estas dos paginas tienen el mismo contenido
        solo que en una hay un link para acceder a la pagina dinamica de la camara y en la otra para acceder a la pagina de la camara, en la pagina dinamica se actualiza la imagen y comentarios cada 30s, ambas paginas tendran un link
        que los envia a la pagina para poner un comentario sobre la imagen que este en ese momento, aparecera un formulario donde se pondra el comentario. En la pagina de la configuracion, podremos cambiar el nombre, tipo de letra y tamano.
        </p>
    </div>
    <footer class="footer bg-dark text-white">
        <div class="container">
            <div class="row">
                <div class="col-md-6">
                    <p class="fs-5">Numero de camaras activas: {{ camaras|length }}</p>
                </div>
                <div class="col-md-6">
                    <p class="fs-5">Numero de comentarios puestos: {{ comentarios|length }}</p>
                </div>
            </div>
        </div>
    </footer>
</body>
</html>

TeVeO/templates/TeVeO/camara.html
<!DOCTYPE html>
{% load static %}

<html lang="en">
<head>
    <meta charset="UTF-8">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <script src="//cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    <link href="{% url 'style' %}" rel="stylesheet">
    <link href="{% url 'bootstrapp' %}" rel="stylesheet">
    <link rel="shortcut icon" type="image/x-icon" href="{% static 'favicon.ico' %}">
    <title>{{ lugar }}</title>
</head>
<body>
    <header>
        <section id="tabs">
            <div class="container green-bg">
                <h6 class="section-title h1"><a href="/">TeVeO</a></h6>
                <h5>Te has registrado como: {{ configuracion.nombre }}</h5>
            </div>
            <div class="container black-bg">
                <nav>
                    <div class="nav nav-tabs nav-fill" id="nav-tab" role="tablist">
                        <a class="nav-item nav-link" id="nav-home-tab" data-toggle="tab" href="/" role="tab" aria-controls="nav-home" aria-selected="true">Principal</a>
                        <a class="nav-item nav-link" id="nav-home-tab" data-toggle="tab" href="/camaras/" role="tab" aria-controls="nav-home" aria-selected="true">Camaras</a>
                        <a class="nav-item nav-link" id="nav-contact-tab" data-toggle="tab" href="/configuracion" role="tab" aria-controls="nav-contact" aria-selected="false">Configuración</a>
                        <a class="nav-item nav-link" id="nav-about-tab" data-toggle="tab" href="/ayuda" role="tab" aria-controls="nav-about" aria-selected="false">Ayuda</a>
                        <a class="nav-item nav-link" id="nav-admin-tab" data-toggle="tab" href="/admin" role="tab" aria-controls="nav-admin" aria-selected="false">Admin</a>
                    </div>
                </nav>
            </div>
        </section>
    </header>
    <hr>
    <div>
        <div id="camarainfo-box">
            <div class="text-container">
                <p>Pagina dinamica <a href="{% url 'camara-dyn' camara.id %}">dinamico</a> </p>
                <p>Nombre: {{ camara.lugar }}</p>
                <p>Latitud: {{ camara.latitud }}</p>
                <p>Longitud: {{ camara.longitud }}</p>
                <p>Para comentar sobre esta imagen <a href="{% url 'comentario' %}?id={{ camara.id }}">Comentario</a></p>


                <form action="" method="POST">
                    {% csrf_token %}
                    <input type="hidden" name="like" value="True">
                    <button type="submit" class="btn btn-danger"><img src = "{% static 'like.jpg' %}" style="width: 35px; height: 35px;">
                    </button>
                </form>
            </div>
            <img src="{{ camara.source }}">
        </div>
    </div>
    <div id="camera-box">
        {% if comentarios %}
            {% for c in comentarios %}
                <div id="comment-box">
                     <div class="text-container">
                        <p>Autor del comentario: {{ c.autor }}</p>
                        <p>Fecha del comentario: {{ c.fecha }}</p>
                        <p>Comentario puesto: {{ c.comentario }}</p>
                     </div>
                    {% if c.imagen %}
                        <img src="data:image/jpeg;base64,{{ c.imagen }}" alt="Imagen">
                    {% endif %}
                </div>
            {% endfor %}
        {% endif %}
    </div>
    <footer class="footer bg-dark text-white">
        <div class="container">
            <div class="row">
                <div class="col-md-6">
                    <p class="fs-5">Numero de camaras activas: {{ longitud_camaras }}</p>
                </div>
                <div class="col-md-6">
                    <p class="fs-5">Numero de comentarios puestos: {{ longitud_comentarios }}</p>
                </div>
            </div>
        </div>
    </footer>

</body>
</html>

TeVeO/templates/TeVeO/camaras.html
<!DOCTYPE html>
{% load static %}

<html lang="en">
<head>
    <meta charset="UTF-8">
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
    <script src="//cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
    <link href="{% url 'style' %}" rel="stylesheet">
    <link href="{% url 'bootstrapp' %}" rel="stylesheet">
    <link rel="shortcut icon" type="image/x-icon" href="{% static 'favicon.ico' %}">
    <title>Camaras</title>
</head>
<body>
    <header>
        <section id="tabs">
            <div class="container green-bg">
                <h6 class="section-title h1"><a href="/">TeVeO</a></h6>
                <h5>Te has registrado como: {{ configuracion.nombre }}</h5>
            </div>
            <div class="container black-bg">
                <nav>
                    <div class="nav nav-tabs nav-fill" id="nav-tab" role="tablist">
                        <a class="nav-item nav-link" id="nav-home-tab" data-toggle="tab" href="/" role="tab" aria-controls="nav-home" aria-selected="true">Principal</a>
                        <a class="nav-item nav-link" id="nav-contact-tab" data-toggle="tab" href="/configuracion" role="tab" aria-controls="nav-contact" aria-selected="false">Configuración</a>
                        <a class="nav-item nav-link" id="nav-about-tab" data-toggle="tab" href="/ayuda" role="tab" aria-controls="nav-about" aria-selected="false">Ayuda</a>
                        <a class="nav-item nav-link" id="nav-admin-tab" data-toggle="tab" href="/admin" role="tab" aria-controls="nav-admin" aria-selected="false">Admin</a>
                    </div>
                </nav>
            </div>
        </section>
    </header>
    <hr>
    {% if imagen_random %}
        <img src="{{ imagen_random.source }}">
    {% endif %}
    <hr>
    <div id="download-box">
        <div class="d-flex align-items-center">
            <p class="me-3">Descargar contenido de lista 1</p>
            <form action="" method="POST">
                {% csrf_token %}
                <input type="hidden" name="lista1" value="lista1">
                <button type="submit" class="btn btn-success">Descargar</button>
            </form>
        </div>
        <div class="d-flex align-items-center">
            <p class="me-3">Descargar contenido de lista 2</p>
            <form action="" method="POST">
                {% csrf_token %}
                <input type="hidden" name="lista2" value="lista2">
                <button type="submit" class="btn btn-success">Descargar</button>
            </form>
        </div>
        <div class="d-flex align-items-center">
            <p class="me-3">Descargar contenido de lista Vitoria</p>
            <form action="" method="POST">
                {% csrf_token %}
                <input type="hidden" name="lista3" value="lista3">
                <button type="submit" class="btn btn-success">Descargar</button>
            </form>
        </div>
        <div class="d-flex align-items-center">
            <p class="me-3">Descargar contenido de lista Galicia</p>
            <form action="" method="POST">
                {% csrf_token %}
                <input type="hidden" name="lista4" value="lista4">
                <button type="submit" class="btn btn-success">Descargar</button>
            </form>
        </div>
    </div>
    <div>
        {% if camaras %}
            <div id="camera-box">
                <p>Camaras</p>
            {% for camara in camaras %}
                <div style="border: 1px solid #ccc; padding: 10px; margin-bottom: 10px; border-radius: 10px;">
                    <button class="btn btn-warning" type="button"><a href="{% url 'jsonCamara' %}?id={{ camara.id }}">JSON</a></button>
                    <p>ID: {{ camara.id }}</p>
                    <p>Nombre camara: {{ camara.lugar }}</p>
                    <p>Pagina de la camara: <a href="{% url 'camara' id=camara.id %}">{{ camara.lugar }}</a></p>
                    <p>Pagina dinamica de la camar<a href="{% url 'camara-dyn' id=camara.id %}">{{ camara.lugar }}</a></p>
                    <p>Numero de comentarios: {{ camara.comentario_set.all|length }} </p>
                    <p>Numero de likes: {{ camara.likecamara_set.all|length }}</p>
            </div>
            {% endfor %}
            </div>
        {% else %}
            <p>No has descargado ningun tipo de contenido</p>
        {% endif %}
    </div>
    {% if camaras %}
        <nav aria-label="Page navigation example">
            <ul class="pagination justify-content-center">
                {% if camaras.has_previous %}
                    <li class="page-item">
                        <a class="page-link link-verde" href="?page=1">&laquo; Primera</a>
                    </li>
                    <li class="page-item">
                        <a class="page-link link-verde" href="?page={{ camaras.previous_page_number }}">Anterior</a>
                    </li>
                {% else %}
                    <li class="page-item disabled">
                        <span class="page-link link-verde">&laquo; Primera</span>
                    </li>
                    <li class="page-item disabled">
                        <span class="page-link link-verde">Anterior</span>
                    </li>
                {% endif %}

                    <li class="page-item active">
                          <span class="page-link link-verde">
                              Página {{ camaras.number }} de {{ camaras.paginator.num_pages }}
                              <span class="sr-only">(current)</span>
                          </span>
                    </li>

                {% if camaras.has_next %}
                    <li class="page-item">
                        <a class="page-link link-verde" href="?page={{ camaras.next_page_number }}">Siguiente</a>
                    </li>
                    <li class="page-item">
                        <a class="page-link link-verde" href="?page={{ camaras.paginator.num_pages }}">Última &raquo;</a>
                    </li>
                {% else %}
                    <li class="page-item disabled">
                        <span class="page-link link-verde">Siguiente</span>
                    </li>
                    <li class="page-item disabled">
                        <span class="page-link link-verde">Última &raquo;</span>
                    </li>
                {% endif %}
            </ul>
        </nav>
    {% endif %}
    <footer class="footer bg-dark text-white">
        <div class="container">
            <div class="row">
                <div class="col-md-6">
                    <p class="fs-5">Numero de camaras activas: {{ camaras|length }}</p>
                </div>
                <div class="col-md-6">
                    <p class="fs-5">Numero de comentarios puestos: {{ longitud_comentarios }}</p>
                </div>
            </div>
        </div>
    </footer>
</body>
</html>